<template>
  <div class="select">
    <p
      class="v-input__hint"
      v-html="hint"
      @click="toggleSelect"
    ></p>
    <div class="v-select__wrapper" @click="toggleSelect" :class="show ? 'open' : ''">
      <span v-if="!selected.code" v-html="placeholder"></span>
      <span v-else v-html="selected.value"></span>
      <div class="select-icon" :class="show ? 'select-close' : ''">
        <selectIcon />
      </div>
    </div>
    <div :class="`select-block ${show ? 'open' : ''}`">
      <ul>
        <li
          v-for="item in options"
          :key="item.code"
          :class="item.code === selected.code ? 'active' : ''"
          v-html="item.value"
          @click="clickItem(item)"
        ></li>
      </ul>
    </div>
  </div>
</template>

<script>
import selectIcon from "../icons/select-icon.vue";

export default {
  components: { selectIcon },
  props: {
    options: { type: Array },
    placeholder: { type: String },
    hint: {
      type: String,
      default: "",
    },
  },
  data() {
    return {
      selected: {},
      show: false,
    };
  },
  methods: {
    toggleSelect() {
      this.show = !this.show;
    },
    clickItem(value) {
      if (this.selected.code === value.code) {
        return (this.selected = {});
      }
      this.selected = value;
      this.show = false;
      this.$emit('update:modelValue', value);
    },
  },
  created() {
      window.addEventListener('click', (e) => {
        if (!this.$el.contains(e.target)){
          this.show = false
        }
      })
  },

}
</script>
